using MINIBROKERLib;
using System;
using System.ComponentModel;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Compiler;

namespace HAGeeks.Premise.WF.Activities
{
    [Validator(typeof(BaseValidator))]
    public class BaseActivity : Activity
    {
        #region Constants
        protected const string RemoteObject = "Remote Object";
        protected const string SysServer = "Sys Server";
        #endregion
        #region Data
        private static readonly ISYSMiniBroker broker = new SYSMiniBrokerClass();
        private static string                  host = "localhost";
        private string                         objectName = string.Empty;
        private static string                  password = "";
        private string                         propertyName = string.Empty;
        private string                         propertyValue = string.Empty;
        private static IRemotePremiseObject    root = null;
        private static string                  userId = "";
        #endregion
        #region Data
        public BaseActivity() : base()
        {
        }
        #endregion
        #region Properties
        protected static ISYSMiniBroker Broker
        {
            get
            {
                return broker;
            }
        }
        [Category(BaseActivity.SysServer)]
        [DefaultValue("localhost")]
        public string Host
        {
            get
            {
                return host;
            }
            set
            {
                host = value;
            }
        }
        [Category(BaseActivity.RemoteObject)]
        [DefaultValue("")]
        public string ObjectName
        {
            get
            {
                return objectName;
            }
            set
            {
                objectName = value;
            }
        }
        [Category(BaseActivity.SysServer)]
        [DefaultValue("")]
        public string Password
        {
            get
            {
                return password;
            }
            set
            {
                password = value;
            }
        }
        [Category(BaseActivity.RemoteObject)]
        [DefaultValue("")]
        public string PropertyName
        {
            get
            {
                return propertyName;
            }
            set
            {
                propertyName = value;
            }
        }
        [Category(BaseActivity.RemoteObject)]
        [DefaultValue("")]
        public virtual string PropertyValue
        {
            get
            {
                return propertyValue;
            }
            set
            {
                propertyValue = value;
            }
        }
        protected static IRemotePremiseObject Root
        {
            get
            {
                if (Broker.connectionStatus != MiniBrokerConnectionStatus.miniBrokerConnected)
                {
                    root = Broker.Connect(host, userId, password);
                }
                return root;
            }
        }
        [Category(BaseActivity.SysServer)]
        [DefaultValue("")]
        public string UserId
        {
            get
            {
                return userId;
            }
            set
            {
                userId = value;
            }
        }
        #endregion
    }
}